-- Old Instance Finder - DrKazza

--Declare Addon and libraries
local OldInstanceFinder = LibStub("AceAddon-3.0"):NewAddon("OldInstanceFinder", "AceConsole-3.0", "AceTimer-3.0")
local OIF = OldInstanceFinder
local wholib = LibStub:GetLibrary("LibWho-2.0"):Library()
local BZ = LibStub("LibBabble-Zone-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("OldInstanceFinder", true)


-- Specify Dungeons
local SearchList = { 
        [1]    = BZ["Naxxramas"], 
        [2]    = BZ["Ulduar"], 
        [3]    = BZ["Temple of Ahn'Qiraj"], 
        [4]    = BZ["Zul'Gurub"],
        [5]    = BZ["Hyjal Summit"],
        [6]    = BZ["Old Hillsbrad Foothills"], 
        [7]    = BZ["The Black Morass"], 
        [8]    = BZ["Karazhan"], 
        [9]    = BZ["Zul'Aman"], 
      [10]    = BZ["Magister's Terrace"], 
      [11]    = BZ["Auchenai Crypts"], 
      [12]    = BZ["Sethekk Halls"], 
      [13]    = BZ["Shadow Labyrinth"], 
      [14]    = BZ["Black Temple"], 
      [15]    = BZ["Serpentshrine Cavern"], 
      [16]    = BZ["The Steamvault"], 
      [17]    = BZ["The Mechanar"], 
      [18]    = BZ["The Botanica"], 
      [19]    = BZ["The Arcatraz"], 
      [20]    = BZ["The Eye"], 
      [21]    = BZ["The Shattered Halls"], 
      [22]    = BZ["The Blood Furnace"], 
      [23]    = BZ["Hellfire Ramparts"], 
      [24]    = BZ["Blackwing Lair"], 
      [25]    = BZ["Molten Core"]
};

 -- Dungeons I don't care about 
	    -- Blackfathom Deeps, Dire Maul, Maraudon, Onyxia's Lair, Ragefire Chasm, Razorfen Downs, Razorfen Kraul 
	    -- Stratholme Past, Ruins of Ahn'Qiraj, Wailing Caverns, Zul'Farrak, Magtheridon's Lair
	    -- Blackrock Depths, Blackrock Spire, Deadmines, Gnomeregan, Sunwell Plateau, Scarlet Monastery (is this 4 locations?) 
	    -- Shadowfang Keep, Stormwind Stockade, Stratholme, Temple of Atal'Hakkar, Uldaman, Mana-Tombs, Scholomance 
	    -- The Slave Pens, The Underbog, Gruul's Lair, Ahn'kahet: The Old Kingdom, Azjol-Nerub, The Obsidian Sanctum 
	    -- Trial of the Champion, Trial of the Crusader, The Forge of Souls, Halls of Reflection, Pit of Saron, 
	    -- The Eye of Eternity, The Oculus, The Nexus, The Violet Hold, Halls of Lightning, Halls of Stone 
	    -- Utgarde Keep, Utgarde Pinnacle, Drak'Tharon Keep, Gundrak 

function OIF:OnInitialize()
    OIF:RegisterChatCommand("OIF", "Slash")
    OIF:RegisterChatCommand("OldInstanceFinder", "Slash")
end

function OIF:OnEnable()
    OIF:Print("OIF Addon Enabled OK")
    OIF:RegisterCallback('WHOLIB_QUERY_RESULT', 'CatchWhoResults')
-- need to find out why this throws an error on enable"
end

function OIF:Slash(msg)
    if msg then
        if tonumber(msg) then
            OIF:StartSearch(msg)
            -- would be nice to enhance to let people do a level range.
            return;
        end
    end
    OIF:Usage()
end

function OIF:Usage()
    OIF:Print("Old Instance Finder, Usage: /oif 80     to search for level 80s or /oif 70 for level 70s etc")
end

function OIF:StartSearch(lvl)

    OIF:Print("Number of dungeons to search is "..#SearchList)
    for i=1, #SearchList do

    searchquery = 'z-'..SearchList[i]..' '..lvl


    local searchresult = wholib:Who(
             searchquery,
         {
             queue = wholib.WHOLIB_QUEUE_SCANNING,
             --flags = whoLib.WHOLIB_FLAG_ALWAYS_CALLBACK,
             callback = self.CatchWhoResults
         });
         if(searchresult) then
             self.CatchWhoResults(searchresult);
         end
    end
end

function OIF:CatchWhoResults(results, complete)
    if results == nil or #results == 0 then
        -- no one in this dungeon
    else
        currentzone = results[1].Zone;
        level = results[1].Level;
        numofrunners = #results;
		if numofrunners == 1 then
			OIF:Print(L["There is one level"].." "..level.." "..L["currently in"].." "..currentzone);
		else
			OIF:Print(numofrunners.." "..L["level"]..level..L["s currently in"].." "..currentzone);
		end
    end
end
